package com.example.demo;

import java.util.Optional;

import org.springframework.dao.OptimisticLockingFailureException;
import org.springframework.retry.annotation.Backoff;
import org.springframework.retry.annotation.Retryable;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class AService {

	private final ARepository aRepository;

	public AService(ARepository aRepository) {
		this.aRepository = aRepository;
	}

	@Transactional
	@Retryable(
		include = { OptimisticLockingFailureException.class },
		maxAttempts = 10,
		backoff = @Backoff(delay = 50, multiplier = 2, random = true)
	)
	public String addB() {
		var a = aRepository.findById("ac5cf47a-55a9-44a3-bb04-c2e88ff0a6b3").get();
		a.getBs().add(new B());
		a.setName(System.nanoTime() + "");
		a = aRepository.save(a);
		return "finish " + a.getBs().size();
	}

	public Optional<A> findById(String s) {
		return this.aRepository.findById(s);
	}

	public boolean existsById(String id) {
		return this.aRepository.existsById(id);
	}

	public A save(A newA) {

		return this.aRepository.save(newA);
	}

	public void deleteAll() {
		this.aRepository.deleteAll();
	}
}
